
		processor pic16f84a
		list r=dec
		

reg1		equ	55
reg2		equ	56

		org	0
		
		movlw	123
		sublw	251		; = 128
		movwf	reg1		; Salvar en registro 55
		rlf	reg1,f		; Rotar a izquierda -> CY
		clrf	reg2    
		rrf	reg2,f		; Rotar a la derecha -> 128

		movlw	0x55		; Preparar 01010101
		xorwf	reg2,f		; XOR con reg2 -> 11010101

		movlw	0x2A
		addwf	reg2,f		; Sumar 0x2a -> 11111111

		incf	reg2,f		; Incrementar -> 00000000
		decf	reg2,f		; Decrementar -> ffffffff

		movlw	0x0f
		andwf	reg2,f		; And con 0x0f -> 0000ffff
		comf	reg2,f		;                 11110000

		swapf	reg2,f		; Intercambio ->  00001111
		bcf	reg2,3		;                 00000111

lazo		decfsz	reg2,f
		goto	lazo
					; reg2 = 00000000
		bsf	reg2,3		;        00001000

		call	invertir
		call	invertir

		movlw	0x0A
		addlw	0x07		; Tiene que generar DC

		movlw	0x80
		addlw	0x80		; Generar Cy

		movlw	5
		sublw	6		; Borrow=1 -> Cy = 0

		movlw	6
		sublw	5		; Borrow=0 -> Cy = 1

morir_aqui	goto	morir_aqui


invertir	movlw	b'11111111'
		xorwf	reg2,f
		return

cargar_W	retlw	0xAA


	
		
		nop
		nop
				
		end
